t / test-lib.shon commit Merge branch 'da/smerge' (5116eab)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Test the binaries we have just built.  The tests are kept in
  19# t/ subdirectory and are run in 'trash directory' subdirectory.
  20if test -z "$TEST_DIRECTORY"
  21then
  22        # We allow tests to override this, in case they want to run tests
  23        # outside of t/, e.g. for running tests on the test library
  24        # itself.
  25        TEST_DIRECTORY=$(pwd)
  26else
  27        # ensure that TEST_DIRECTORY is an absolute path so that it
  28        # is valid even if the current working directory is changed
  29        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  30fi
  31if test -z "$TEST_OUTPUT_DIRECTORY"
  32then
  33        # Similarly, override this to store the test-results subdir
  34        # elsewhere
  35        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  36fi
  37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  38
  39# If we were built with ASAN, it may complain about leaks
  40# of program-lifetime variables. Disable it by default to lower
  41# the noise level. This needs to happen at the start of the script,
  42# before we even do our "did we build git yet" check (since we don't
  43# want that one to complain to stderr).
  44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
  45export ASAN_OPTIONS
  46
  47# If LSAN is in effect we _do_ want leak checking, but we still
  48# want to abort so that we notice the problems.
  49: ${LSAN_OPTIONS=abort_on_error=1}
  50export LSAN_OPTIONS
  51
  52if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  53then
  54        echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
  55        exit 1
  56fi
  57. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  58export PERL_PATH SHELL_PATH
  59
  60# Disallow the use of abbreviated options in the test suite by default
  61if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
  62then
  63        GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
  64        export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
  65fi
  66
  67################################################################
  68# It appears that people try to run tests without building...
  69"${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
  70if test $? != 1
  71then
  72        if test -n "$GIT_TEST_INSTALLED"
  73        then
  74                echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
  75        else
  76                echo >&2 'error: you do not seem to have built git yet.'
  77        fi
  78        exit 1
  79fi
  80
  81# Parse options while taking care to leave $@ intact, so we will still
  82# have all the original command line options when executing the test
  83# script again for '--tee' and '--verbose-log' below.
  84store_arg_to=
  85prev_opt=
  86for opt
  87do
  88        if test -n "$store_arg_to"
  89        then
  90                eval $store_arg_to=\$opt
  91                store_arg_to=
  92                prev_opt=
  93                continue
  94        fi
  95
  96        case "$opt" in
  97        -d|--d|--de|--deb|--debu|--debug)
  98                debug=t ;;
  99        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 100                immediate=t ;;
 101        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 102                GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
 103        -r)
 104                store_arg_to=run_list
 105                ;;
 106        --run=*)
 107                run_list=${opt#--*=} ;;
 108        -h|--h|--he|--hel|--help)
 109                help=t ;;
 110        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 111                verbose=t ;;
 112        --verbose-only=*)
 113                verbose_only=${opt#--*=}
 114                ;;
 115        -q|--q|--qu|--qui|--quie|--quiet)
 116                # Ignore --quiet under a TAP::Harness. Saying how many tests
 117                # passed without the ok/not ok details is always an error.
 118                test -z "$HARNESS_ACTIVE" && quiet=t ;;
 119        --with-dashes)
 120                with_dashes=t ;;
 121        --no-bin-wrappers)
 122                no_bin_wrappers=t ;;
 123        --no-color)
 124                color= ;;
 125        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 126                valgrind=memcheck
 127                tee=t
 128                ;;
 129        --valgrind=*)
 130                valgrind=${opt#--*=}
 131                tee=t
 132                ;;
 133        --valgrind-only=*)
 134                valgrind_only=${opt#--*=}
 135                tee=t
 136                ;;
 137        --tee)
 138                tee=t ;;
 139        --root=*)
 140                root=${opt#--*=} ;;
 141        --chain-lint)
 142                GIT_TEST_CHAIN_LINT=1 ;;
 143        --no-chain-lint)
 144                GIT_TEST_CHAIN_LINT=0 ;;
 145        -x)
 146                trace=t ;;
 147        -V|--verbose-log)
 148                verbose_log=t
 149                tee=t
 150                ;;
 151        --write-junit-xml)
 152                write_junit_xml=t
 153                ;;
 154        --stress)
 155                stress=t ;;
 156        --stress=*)
 157                echo "error: --stress does not accept an argument: '$opt'" >&2
 158                echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
 159                exit 1
 160                ;;
 161        --stress-jobs=*)
 162                stress=t;
 163                stress=${opt#--*=}
 164                case "$stress" in
 165                *[!0-9]*|0*|"")
 166                        echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
 167                        exit 1
 168                        ;;
 169                *)      # Good.
 170                        ;;
 171                esac
 172                ;;
 173        --stress-limit=*)
 174                stress=t;
 175                stress_limit=${opt#--*=}
 176                case "$stress_limit" in
 177                *[!0-9]*|0*|"")
 178                        echo "error: --stress-limit=<N> requires the number of repetitions" >&2
 179                        exit 1
 180                        ;;
 181                *)      # Good.
 182                        ;;
 183                esac
 184                ;;
 185        *)
 186                echo "error: unknown test option '$opt'" >&2; exit 1 ;;
 187        esac
 188
 189        prev_opt=$opt
 190done
 191if test -n "$store_arg_to"
 192then
 193        echo "error: $prev_opt requires an argument" >&2
 194        exit 1
 195fi
 196
 197if test -n "$valgrind_only"
 198then
 199        test -z "$valgrind" && valgrind=memcheck
 200        test -z "$verbose" && verbose_only="$valgrind_only"
 201elif test -n "$valgrind"
 202then
 203        test -z "$verbose_log" && verbose=t
 204fi
 205
 206if test -n "$stress"
 207then
 208        verbose=t
 209        trace=t
 210        immediate=t
 211fi
 212
 213TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
 214TEST_NAME="$(basename "$0" .sh)"
 215TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
 216TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
 217TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
 218test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 219case "$TRASH_DIRECTORY" in
 220/*) ;; # absolute path is good
 221 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 222esac
 223
 224# If --stress was passed, run this test repeatedly in several parallel loops.
 225if test "$GIT_TEST_STRESS_STARTED" = "done"
 226then
 227        : # Don't stress test again.
 228elif test -n "$stress"
 229then
 230        if test "$stress" != t
 231        then
 232                job_count=$stress
 233        elif test -n "$GIT_TEST_STRESS_LOAD"
 234        then
 235                job_count="$GIT_TEST_STRESS_LOAD"
 236        elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
 237             test -n "$job_count"
 238        then
 239                job_count=$((2 * $job_count))
 240        else
 241                job_count=8
 242        fi
 243
 244        mkdir -p "$TEST_RESULTS_DIR"
 245        stressfail="$TEST_RESULTS_BASE.stress-failed"
 246        rm -f "$stressfail"
 247
 248        stress_exit=0
 249        trap '
 250                kill $job_pids 2>/dev/null
 251                wait
 252                stress_exit=1
 253        ' TERM INT HUP
 254
 255        job_pids=
 256        job_nr=0
 257        while test $job_nr -lt "$job_count"
 258        do
 259                (
 260                        GIT_TEST_STRESS_STARTED=done
 261                        GIT_TEST_STRESS_JOB_NR=$job_nr
 262                        export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
 263
 264                        trap '
 265                                kill $test_pid 2>/dev/null
 266                                wait
 267                                exit 1
 268                        ' TERM INT
 269
 270                        cnt=1
 271                        while ! test -e "$stressfail" &&
 272                              { test -z "$stress_limit" ||
 273                                test $cnt -le $stress_limit ; }
 274                        do
 275                                $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
 276                                test_pid=$!
 277
 278                                if wait $test_pid
 279                                then
 280                                        printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 281                                else
 282                                        echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
 283                                        printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
 284                                fi
 285                                cnt=$(($cnt + 1))
 286                        done
 287                ) &
 288                job_pids="$job_pids $!"
 289                job_nr=$(($job_nr + 1))
 290        done
 291
 292        wait
 293
 294        if test -f "$stressfail"
 295        then
 296                stress_exit=1
 297                echo "Log(s) of failed test run(s):"
 298                for failed_job_nr in $(sort -n "$stressfail")
 299                do
 300                        echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
 301                        cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
 302                done
 303                rm -rf "$TRASH_DIRECTORY.stress-failed"
 304                # Move the last one.
 305                mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
 306        fi
 307
 308        exit $stress_exit
 309fi
 310
 311# if --tee was passed, write the output not only to the terminal, but
 312# additionally to the file test-results/$BASENAME.out, too.
 313if test "$GIT_TEST_TEE_STARTED" = "done"
 314then
 315        : # do not redirect again
 316elif test -n "$tee"
 317then
 318        mkdir -p "$TEST_RESULTS_DIR"
 319
 320        # Make this filename available to the sub-process in case it is using
 321        # --verbose-log.
 322        GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
 323        export GIT_TEST_TEE_OUTPUT_FILE
 324
 325        # Truncate before calling "tee -a" to get rid of the results
 326        # from any previous runs.
 327        >"$GIT_TEST_TEE_OUTPUT_FILE"
 328
 329        (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
 330         echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
 331        test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
 332        exit
 333fi
 334
 335if test -n "$trace" && test -n "$test_untraceable"
 336then
 337        # '-x' tracing requested, but this test script can't be reliably
 338        # traced, unless it is run with a Bash version supporting
 339        # BASH_XTRACEFD (introduced in Bash v4.1).
 340        #
 341        # Perform this version check _after_ the test script was
 342        # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
 343        # '--verbose-log', so the right shell is checked and the
 344        # warning is issued only once.
 345        if test -n "$BASH_VERSION" && eval '
 346             test ${BASH_VERSINFO[0]} -gt 4 || {
 347               test ${BASH_VERSINFO[0]} -eq 4 &&
 348               test ${BASH_VERSINFO[1]} -ge 1
 349             }
 350           '
 351        then
 352                : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
 353        else
 354                echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
 355                trace=
 356        fi
 357fi
 358if test -n "$trace" && test -z "$verbose_log"
 359then
 360        verbose=t
 361fi
 362
 363# For repeatability, reset the environment to known value.
 364# TERM is sanitized below, after saving color control sequences.
 365LANG=C
 366LC_ALL=C
 367PAGER=cat
 368TZ=UTC
 369export LANG LC_ALL PAGER TZ
 370EDITOR=:
 371
 372# GIT_TEST_GETTEXT_POISON should not influence git commands executed
 373# during initialization of test-lib and the test repo. Back it up,
 374# unset and then restore after initialization is finished.
 375if test -n "$GIT_TEST_GETTEXT_POISON"
 376then
 377        GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
 378        unset GIT_TEST_GETTEXT_POISON
 379fi
 380
 381# A call to "unset" with no arguments causes at least Solaris 10
 382# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
 383# deriving from the command substitution clustered with the other
 384# ones.
 385unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
 386        my @env = keys %ENV;
 387        my $ok = join("|", qw(
 388                TRACE
 389                DEBUG
 390                TEST
 391                .*_TEST
 392                PROVE
 393                VALGRIND
 394                UNZIP
 395                PERF_
 396                CURL_VERBOSE
 397                TRACE_CURL
 398        ));
 399        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
 400        print join("\n", @vars);
 401')
 402unset XDG_CACHE_HOME
 403unset XDG_CONFIG_HOME
 404unset GITPERLLIB
 405GIT_AUTHOR_EMAIL=author@example.com
 406GIT_AUTHOR_NAME='A U Thor'
 407GIT_COMMITTER_EMAIL=committer@example.com
 408GIT_COMMITTER_NAME='C O Mitter'
 409GIT_MERGE_VERBOSITY=5
 410GIT_MERGE_AUTOEDIT=no
 411export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 412export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 413export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 414export EDITOR
 415
 416# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 417GIT_TRACE_BARE=1
 418export GIT_TRACE_BARE
 419
 420check_var_migration () {
 421        # the warnings and hints given from this helper depends
 422        # on end-user settings, which will disrupt the self-test
 423        # done on the test framework itself.
 424        case "$GIT_TEST_FRAMEWORK_SELFTEST" in
 425        t)      return ;;
 426        esac
 427
 428        old_name=$1 new_name=$2
 429        eval "old_isset=\${${old_name}:+isset}"
 430        eval "new_isset=\${${new_name}:+isset}"
 431
 432        case "$old_isset,$new_isset" in
 433        isset,)
 434                echo >&2 "warning: $old_name is now $new_name"
 435                echo >&2 "hint: set $new_name too during the transition period"
 436                eval "$new_name=\$$old_name"
 437                ;;
 438        isset,isset)
 439                # do this later
 440                # echo >&2 "warning: $old_name is now $new_name"
 441                # echo >&2 "hint: remove $old_name"
 442                ;;
 443        esac
 444}
 445
 446check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
 447check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
 448check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
 449
 450# Use specific version of the index file format
 451if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
 452then
 453        GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
 454        export GIT_INDEX_VERSION
 455fi
 456
 457# Add libc MALLOC and MALLOC_PERTURB test
 458# only if we are not executing the test with valgrind
 459if test -n "$valgrind" ||
 460   test -n "$TEST_NO_MALLOC_CHECK"
 461then
 462        setup_malloc_check () {
 463                : nothing
 464        }
 465        teardown_malloc_check () {
 466                : nothing
 467        }
 468else
 469        setup_malloc_check () {
 470                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 471                export MALLOC_CHECK_ MALLOC_PERTURB_
 472        }
 473        teardown_malloc_check () {
 474                unset MALLOC_CHECK_ MALLOC_PERTURB_
 475        }
 476fi
 477
 478# Protect ourselves from common misconfiguration to export
 479# CDPATH into the environment
 480unset CDPATH
 481
 482unset GREP_OPTIONS
 483unset UNZIP
 484
 485case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 4861|2|true)
 487        GIT_TRACE=4
 488        ;;
 489esac
 490
 491# Convenience
 492#
 493# A regexp to match 5, 35 and 40 hexdigits
 494_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 495_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 496_x40="$_x35$_x05"
 497
 498# Zero SHA-1
 499_z40=0000000000000000000000000000000000000000
 500
 501OID_REGEX="$_x40"
 502ZERO_OID=$_z40
 503EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 504EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
 505
 506# Line feed
 507LF='
 508'
 509
 510# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 511# when case-folding filenames
 512u200c=$(printf '\342\200\214')
 513
 514export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
 515
 516# Each test should start with something like this, after copyright notices:
 517#
 518# test_description='Description of this test...
 519# This test checks if command xyzzy does the right thing...
 520# '
 521# . ./test-lib.sh
 522test "x$TERM" != "xdumb" && (
 523                test -t 1 &&
 524                tput bold >/dev/null 2>&1 &&
 525                tput setaf 1 >/dev/null 2>&1 &&
 526                tput sgr0 >/dev/null 2>&1
 527        ) &&
 528        color=t
 529
 530if test -n "$color"
 531then
 532        # Save the color control sequences now rather than run tput
 533        # each time say_color() is called.  This is done for two
 534        # reasons:
 535        #   * TERM will be changed to dumb
 536        #   * HOME will be changed to a temporary directory and tput
 537        #     might need to read ~/.terminfo from the original HOME
 538        #     directory to get the control sequences
 539        # Note:  This approach assumes the control sequences don't end
 540        # in a newline for any terminal of interest (command
 541        # substitutions strip trailing newlines).  Given that most
 542        # (all?) terminals in common use are related to ECMA-48, this
 543        # shouldn't be a problem.
 544        say_color_error=$(tput bold; tput setaf 1) # bold red
 545        say_color_skip=$(tput setaf 4) # blue
 546        say_color_warn=$(tput setaf 3) # brown/yellow
 547        say_color_pass=$(tput setaf 2) # green
 548        say_color_info=$(tput setaf 6) # cyan
 549        say_color_reset=$(tput sgr0)
 550        say_color_="" # no formatting for normal text
 551        say_color () {
 552                test -z "$1" && test -n "$quiet" && return
 553                eval "say_color_color=\$say_color_$1"
 554                shift
 555                printf "%s\\n" "$say_color_color$*$say_color_reset"
 556        }
 557else
 558        say_color() {
 559                test -z "$1" && test -n "$quiet" && return
 560                shift
 561                printf "%s\n" "$*"
 562        }
 563fi
 564
 565TERM=dumb
 566export TERM
 567
 568error () {
 569        say_color error "error: $*"
 570        GIT_EXIT_OK=t
 571        exit 1
 572}
 573
 574BUG () {
 575        error >&7 "bug in the test script: $*"
 576}
 577
 578say () {
 579        say_color info "$*"
 580}
 581
 582if test -n "$HARNESS_ACTIVE"
 583then
 584        if test "$verbose" = t || test -n "$verbose_only"
 585        then
 586                printf 'Bail out! %s\n' \
 587                 'verbose mode forbidden under TAP harness; try --verbose-log'
 588                exit 1
 589        fi
 590fi
 591
 592test "${test_description}" != "" ||
 593error "Test script did not set test_description."
 594
 595if test "$help" = "t"
 596then
 597        printf '%s\n' "$test_description"
 598        exit 0
 599fi
 600
 601exec 5>&1
 602exec 6<&0
 603exec 7>&2
 604if test "$verbose_log" = "t"
 605then
 606        exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
 607elif test "$verbose" = "t"
 608then
 609        exec 4>&2 3>&1
 610else
 611        exec 4>/dev/null 3>/dev/null
 612fi
 613
 614# Send any "-x" output directly to stderr to avoid polluting tests
 615# which capture stderr. We can do this unconditionally since it
 616# has no effect if tracing isn't turned on.
 617#
 618# Note that this sets up the trace fd as soon as we assign the variable, so it
 619# must come after the creation of descriptor 4 above. Likewise, we must never
 620# unset this, as it has the side effect of closing descriptor 4, which we
 621# use to show verbose tests to the user.
 622#
 623# Note also that we don't need or want to export it. The tracing is local to
 624# this shell, and we would not want to influence any shells we exec.
 625BASH_XTRACEFD=4
 626
 627test_failure=0
 628test_count=0
 629test_fixed=0
 630test_broken=0
 631test_success=0
 632
 633test_external_has_tap=0
 634
 635die () {
 636        code=$?
 637        if test -n "$GIT_EXIT_OK"
 638        then
 639                exit $code
 640        else
 641                echo >&5 "FATAL: Unexpected exit with code $code"
 642                exit 1
 643        fi
 644}
 645
 646GIT_EXIT_OK=
 647trap 'die' EXIT
 648trap 'exit $?' INT TERM HUP
 649
 650# The user-facing functions are loaded from a separate file so that
 651# test_perf subshells can have them too
 652. "$TEST_DIRECTORY/test-lib-functions.sh"
 653
 654# You are not expected to call test_ok_ and test_failure_ directly, use
 655# the test_expect_* functions instead.
 656
 657test_ok_ () {
 658        if test -n "$write_junit_xml"
 659        then
 660                write_junit_xml_testcase "$*"
 661        fi
 662        test_success=$(($test_success + 1))
 663        say_color "" "ok $test_count - $@"
 664}
 665
 666test_failure_ () {
 667        if test -n "$write_junit_xml"
 668        then
 669                junit_insert="<failure message=\"not ok $test_count -"
 670                junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
 671                junit_insert="$junit_insert $(xml_attr_encode \
 672                        "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 673                           then
 674                                test-tool path-utils skip-n-bytes \
 675                                        "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
 676                           else
 677                                printf '%s\n' "$@" | sed 1d
 678                           fi)")"
 679                junit_insert="$junit_insert</failure>"
 680                if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
 681                then
 682                        junit_insert="$junit_insert<system-err>$(xml_attr_encode \
 683                                "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
 684                fi
 685                write_junit_xml_testcase "$1" "      $junit_insert"
 686        fi
 687        test_failure=$(($test_failure + 1))
 688        say_color error "not ok $test_count - $1"
 689        shift
 690        printf '%s\n' "$*" | sed -e 's/^/#      /'
 691        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 692}
 693
 694test_known_broken_ok_ () {
 695        if test -n "$write_junit_xml"
 696        then
 697                write_junit_xml_testcase "$* (breakage fixed)"
 698        fi
 699        test_fixed=$(($test_fixed+1))
 700        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 701}
 702
 703test_known_broken_failure_ () {
 704        if test -n "$write_junit_xml"
 705        then
 706                write_junit_xml_testcase "$* (known breakage)"
 707        fi
 708        test_broken=$(($test_broken+1))
 709        say_color warn "not ok $test_count - $@ # TODO known breakage"
 710}
 711
 712test_debug () {
 713        test "$debug" = "" || eval "$1"
 714}
 715
 716match_pattern_list () {
 717        arg="$1"
 718        shift
 719        test -z "$*" && return 1
 720        for pattern_
 721        do
 722                case "$arg" in
 723                $pattern_)
 724                        return 0
 725                esac
 726        done
 727        return 1
 728}
 729
 730match_test_selector_list () {
 731        title="$1"
 732        shift
 733        arg="$1"
 734        shift
 735        test -z "$1" && return 0
 736
 737        # Both commas and whitespace are accepted as separators.
 738        OLDIFS=$IFS
 739        IFS='   ,'
 740        set -- $1
 741        IFS=$OLDIFS
 742
 743        # If the first selector is negative we include by default.
 744        include=
 745        case "$1" in
 746                !*) include=t ;;
 747        esac
 748
 749        for selector
 750        do
 751                orig_selector=$selector
 752
 753                positive=t
 754                case "$selector" in
 755                        !*)
 756                                positive=
 757                                selector=${selector##?}
 758                                ;;
 759                esac
 760
 761                test -z "$selector" && continue
 762
 763                case "$selector" in
 764                        *-*)
 765                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 766                                then
 767                                        echo "error: $title: invalid non-numeric in range" \
 768                                                "start: '$orig_selector'" >&2
 769                                        exit 1
 770                                fi
 771                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 772                                then
 773                                        echo "error: $title: invalid non-numeric in range" \
 774                                                "end: '$orig_selector'" >&2
 775                                        exit 1
 776                                fi
 777                                ;;
 778                        *)
 779                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 780                                then
 781                                        echo "error: $title: invalid non-numeric in test" \
 782                                                "selector: '$orig_selector'" >&2
 783                                        exit 1
 784                                fi
 785                esac
 786
 787                # Short cut for "obvious" cases
 788                test -z "$include" && test -z "$positive" && continue
 789                test -n "$include" && test -n "$positive" && continue
 790
 791                case "$selector" in
 792                        -*)
 793                                if test $arg -le ${selector#-}
 794                                then
 795                                        include=$positive
 796                                fi
 797                                ;;
 798                        *-)
 799                                if test $arg -ge ${selector%-}
 800                                then
 801                                        include=$positive
 802                                fi
 803                                ;;
 804                        *-*)
 805                                if test ${selector%%-*} -le $arg \
 806                                        && test $arg -le ${selector#*-}
 807                                then
 808                                        include=$positive
 809                                fi
 810                                ;;
 811                        *)
 812                                if test $arg -eq $selector
 813                                then
 814                                        include=$positive
 815                                fi
 816                                ;;
 817                esac
 818        done
 819
 820        test -n "$include"
 821}
 822
 823maybe_teardown_verbose () {
 824        test -z "$verbose_only" && return
 825        exec 4>/dev/null 3>/dev/null
 826        verbose=
 827}
 828
 829last_verbose=t
 830maybe_setup_verbose () {
 831        test -z "$verbose_only" && return
 832        if match_pattern_list $test_count $verbose_only
 833        then
 834                exec 4>&2 3>&1
 835                # Emit a delimiting blank line when going from
 836                # non-verbose to verbose.  Within verbose mode the
 837                # delimiter is printed by test_expect_*.  The choice
 838                # of the initial $last_verbose is such that before
 839                # test 1, we do not print it.
 840                test -z "$last_verbose" && echo >&3 ""
 841                verbose=t
 842        else
 843                exec 4>/dev/null 3>/dev/null
 844                verbose=
 845        fi
 846        last_verbose=$verbose
 847}
 848
 849maybe_teardown_valgrind () {
 850        test -z "$GIT_VALGRIND" && return
 851        GIT_VALGRIND_ENABLED=
 852}
 853
 854maybe_setup_valgrind () {
 855        test -z "$GIT_VALGRIND" && return
 856        if test -z "$valgrind_only"
 857        then
 858                GIT_VALGRIND_ENABLED=t
 859                return
 860        fi
 861        GIT_VALGRIND_ENABLED=
 862        if match_pattern_list $test_count $valgrind_only
 863        then
 864                GIT_VALGRIND_ENABLED=t
 865        fi
 866}
 867
 868want_trace () {
 869        test "$trace" = t && {
 870                test "$verbose" = t || test "$verbose_log" = t
 871        }
 872}
 873
 874# This is a separate function because some tests use
 875# "return" to end a test_expect_success block early
 876# (and we want to make sure we run any cleanup like
 877# "set +x").
 878test_eval_inner_ () {
 879        # Do not add anything extra (including LF) after '$*'
 880        eval "
 881                want_trace && set -x
 882                $*"
 883}
 884
 885test_eval_ () {
 886        # If "-x" tracing is in effect, then we want to avoid polluting stderr
 887        # with non-test commands. But once in "set -x" mode, we cannot prevent
 888        # the shell from printing the "set +x" to turn it off (nor the saving
 889        # of $? before that). But we can make sure that the output goes to
 890        # /dev/null.
 891        #
 892        # There are a few subtleties here:
 893        #
 894        #   - we have to redirect descriptor 4 in addition to 2, to cover
 895        #     BASH_XTRACEFD
 896        #
 897        #   - the actual eval has to come before the redirection block (since
 898        #     it needs to see descriptor 4 to set up its stderr)
 899        #
 900        #   - likewise, any error message we print must be outside the block to
 901        #     access descriptor 4
 902        #
 903        #   - checking $? has to come immediately after the eval, but it must
 904        #     be _inside_ the block to avoid polluting the "set -x" output
 905        #
 906
 907        test_eval_inner_ "$@" </dev/null >&3 2>&4
 908        {
 909                test_eval_ret_=$?
 910                if want_trace
 911                then
 912                        set +x
 913                fi
 914        } 2>/dev/null 4>&2
 915
 916        if test "$test_eval_ret_" != 0 && want_trace
 917        then
 918                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 919        fi
 920        return $test_eval_ret_
 921}
 922
 923test_run_ () {
 924        test_cleanup=:
 925        expecting_failure=$2
 926
 927        if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
 928                # turn off tracing for this test-eval, as it simply creates
 929                # confusing noise in the "-x" output
 930                trace_tmp=$trace
 931                trace=
 932                # 117 is magic because it is unlikely to match the exit
 933                # code of other programs
 934                if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
 935                        test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
 936                then
 937                        BUG "broken &&-chain or run-away HERE-DOC: $1"
 938                fi
 939                trace=$trace_tmp
 940        fi
 941
 942        setup_malloc_check
 943        test_eval_ "$1"
 944        eval_ret=$?
 945        teardown_malloc_check
 946
 947        if test -z "$immediate" || test $eval_ret = 0 ||
 948           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 949        then
 950                setup_malloc_check
 951                test_eval_ "$test_cleanup"
 952                teardown_malloc_check
 953        fi
 954        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 955        then
 956                echo ""
 957        fi
 958        return "$eval_ret"
 959}
 960
 961test_start_ () {
 962        test_count=$(($test_count+1))
 963        maybe_setup_verbose
 964        maybe_setup_valgrind
 965        if test -n "$write_junit_xml"
 966        then
 967                junit_start=$(test-tool date getnanos)
 968        fi
 969}
 970
 971test_finish_ () {
 972        echo >&3 ""
 973        maybe_teardown_valgrind
 974        maybe_teardown_verbose
 975        if test -n "$GIT_TEST_TEE_OFFSET"
 976        then
 977                GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
 978                        "$GIT_TEST_TEE_OUTPUT_FILE")
 979        fi
 980}
 981
 982test_skip () {
 983        to_skip=
 984        skipped_reason=
 985        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 986        then
 987                to_skip=t
 988                skipped_reason="GIT_SKIP_TESTS"
 989        fi
 990        if test -z "$to_skip" && test -n "$test_prereq" &&
 991           ! test_have_prereq "$test_prereq"
 992        then
 993                to_skip=t
 994
 995                of_prereq=
 996                if test "$missing_prereq" != "$test_prereq"
 997                then
 998                        of_prereq=" of $test_prereq"
 999                fi
1000                skipped_reason="missing $missing_prereq${of_prereq}"
1001        fi
1002        if test -z "$to_skip" && test -n "$run_list" &&
1003                ! match_test_selector_list '--run' $test_count "$run_list"
1004        then
1005                to_skip=t
1006                skipped_reason="--run"
1007        fi
1008
1009        case "$to_skip" in
1010        t)
1011                if test -n "$write_junit_xml"
1012                then
1013                        message="$(xml_attr_encode "$skipped_reason")"
1014                        write_junit_xml_testcase "$1" \
1015                                "      <skipped message=\"$message\" />"
1016                fi
1017
1018                say_color skip >&3 "skipping test: $@"
1019                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1020                : true
1021                ;;
1022        *)
1023                false
1024                ;;
1025        esac
1026}
1027
1028# stub; perf-lib overrides it
1029test_at_end_hook_ () {
1030        :
1031}
1032
1033write_junit_xml () {
1034        case "$1" in
1035        --truncate)
1036                >"$junit_xml_path"
1037                junit_have_testcase=
1038                shift
1039                ;;
1040        esac
1041        printf '%s\n' "$@" >>"$junit_xml_path"
1042}
1043
1044xml_attr_encode () {
1045        printf '%s\n' "$@" | test-tool xml-encode
1046}
1047
1048write_junit_xml_testcase () {
1049        junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1050        shift
1051        junit_attrs="$junit_attrs classname=\"$this_test\""
1052        junit_attrs="$junit_attrs time=\"$(test-tool \
1053                date getnanos $junit_start)\""
1054        write_junit_xml "$(printf '%s\n' \
1055                "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1056        junit_have_testcase=t
1057}
1058
1059test_done () {
1060        GIT_EXIT_OK=t
1061
1062        if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1063        then
1064                test -n "$junit_have_testcase" || {
1065                        junit_start=$(test-tool date getnanos)
1066                        write_junit_xml_testcase "all tests skipped"
1067                }
1068
1069                # adjust the overall time
1070                junit_time=$(test-tool date getnanos $junit_suite_start)
1071                sed "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1072                        <"$junit_xml_path" >"$junit_xml_path.new"
1073                mv "$junit_xml_path.new" "$junit_xml_path"
1074
1075                write_junit_xml "  </testsuite>" "</testsuites>"
1076        fi
1077
1078        if test -z "$HARNESS_ACTIVE"
1079        then
1080                mkdir -p "$TEST_RESULTS_DIR"
1081
1082                cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1083                total $test_count
1084                success $test_success
1085                fixed $test_fixed
1086                broken $test_broken
1087                failed $test_failure
1088
1089                EOF
1090        fi
1091
1092        if test "$test_fixed" != 0
1093        then
1094                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1095        fi
1096        if test "$test_broken" != 0
1097        then
1098                say_color warn "# still have $test_broken known breakage(s)"
1099        fi
1100        if test "$test_broken" != 0 || test "$test_fixed" != 0
1101        then
1102                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1103                msg="remaining $test_remaining test(s)"
1104        else
1105                test_remaining=$test_count
1106                msg="$test_count test(s)"
1107        fi
1108        case "$test_failure" in
1109        0)
1110                if test $test_external_has_tap -eq 0
1111                then
1112                        if test $test_remaining -gt 0
1113                        then
1114                                say_color pass "# passed all $msg"
1115                        fi
1116
1117                        # Maybe print SKIP message
1118                        test -z "$skip_all" || skip_all="# SKIP $skip_all"
1119                        case "$test_count" in
1120                        0)
1121                                say "1..$test_count${skip_all:+ $skip_all}"
1122                                ;;
1123                        *)
1124                                test -z "$skip_all" ||
1125                                say_color warn "$skip_all"
1126                                say "1..$test_count"
1127                                ;;
1128                        esac
1129                fi
1130
1131                if test -z "$debug"
1132                then
1133                        test -d "$TRASH_DIRECTORY" ||
1134                        error "Tests passed but trash directory already removed before test cleanup; aborting"
1135
1136                        cd "$TRASH_DIRECTORY/.." &&
1137                        rm -fr "$TRASH_DIRECTORY" || {
1138                                # try again in a bit
1139                                sleep 5;
1140                                rm -fr "$TRASH_DIRECTORY"
1141                        } ||
1142                        error "Tests passed but test cleanup failed; aborting"
1143                fi
1144                test_at_end_hook_
1145
1146                exit 0 ;;
1147
1148        *)
1149                if test $test_external_has_tap -eq 0
1150                then
1151                        say_color error "# failed $test_failure among $msg"
1152                        say "1..$test_count"
1153                fi
1154
1155                exit 1 ;;
1156
1157        esac
1158}
1159
1160if test -n "$valgrind"
1161then
1162        make_symlink () {
1163                test -h "$2" &&
1164                test "$1" = "$(readlink "$2")" || {
1165                        # be super paranoid
1166                        if mkdir "$2".lock
1167                        then
1168                                rm -f "$2" &&
1169                                ln -s "$1" "$2" &&
1170                                rm -r "$2".lock
1171                        else
1172                                while test -d "$2".lock
1173                                do
1174                                        say "Waiting for lock on $2."
1175                                        sleep 1
1176                                done
1177                        fi
1178                }
1179        }
1180
1181        make_valgrind_symlink () {
1182                # handle only executables, unless they are shell libraries that
1183                # need to be in the exec-path.
1184                test -x "$1" ||
1185                test "# " = "$(test_copy_bytes 2 <"$1")" ||
1186                return;
1187
1188                base=$(basename "$1")
1189                case "$base" in
1190                test-*)
1191                        symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1192                        ;;
1193                *)
1194                        symlink_target="$GIT_BUILD_DIR/$base"
1195                        ;;
1196                esac
1197                # do not override scripts
1198                if test -x "$symlink_target" &&
1199                    test ! -d "$symlink_target" &&
1200                    test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1201                then
1202                        symlink_target=../valgrind.sh
1203                fi
1204                case "$base" in
1205                *.sh|*.perl)
1206                        symlink_target=../unprocessed-script
1207                esac
1208                # create the link, or replace it if it is out of date
1209                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1210        }
1211
1212        # override all git executables in TEST_DIRECTORY/..
1213        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1214        mkdir -p "$GIT_VALGRIND"/bin
1215        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1216        do
1217                make_valgrind_symlink $file
1218        done
1219        # special-case the mergetools loadables
1220        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1221        OLDIFS=$IFS
1222        IFS=:
1223        for path in $PATH
1224        do
1225                ls "$path"/git-* 2> /dev/null |
1226                while read file
1227                do
1228                        make_valgrind_symlink "$file"
1229                done
1230        done
1231        IFS=$OLDIFS
1232        PATH=$GIT_VALGRIND/bin:$PATH
1233        GIT_EXEC_PATH=$GIT_VALGRIND/bin
1234        export GIT_VALGRIND
1235        GIT_VALGRIND_MODE="$valgrind"
1236        export GIT_VALGRIND_MODE
1237        GIT_VALGRIND_ENABLED=t
1238        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1239        export GIT_VALGRIND_ENABLED
1240elif test -n "$GIT_TEST_INSTALLED"
1241then
1242        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1243        error "Cannot run git from $GIT_TEST_INSTALLED."
1244        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1245        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1246else # normal case, use ../bin-wrappers only unless $with_dashes:
1247        if test -n "$no_bin_wrappers"
1248        then
1249                with_dashes=t
1250        else
1251                git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1252                if ! test -x "$git_bin_dir/git"
1253                then
1254                        if test -z "$with_dashes"
1255                        then
1256                                say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1257                        fi
1258                        with_dashes=t
1259                fi
1260                PATH="$git_bin_dir:$PATH"
1261        fi
1262        GIT_EXEC_PATH=$GIT_BUILD_DIR
1263        if test -n "$with_dashes"
1264        then
1265                PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1266        fi
1267fi
1268GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1269GIT_CONFIG_NOSYSTEM=1
1270GIT_ATTR_NOSYSTEM=1
1271export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1272
1273if test -z "$GIT_TEST_CMP"
1274then
1275        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1276        then
1277                GIT_TEST_CMP="$DIFF -c"
1278        else
1279                GIT_TEST_CMP="$DIFF -u"
1280        fi
1281fi
1282
1283GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1284export GITPERLLIB
1285test -d "$GIT_BUILD_DIR"/templates/blt || {
1286        error "You haven't built things yet, have you?"
1287}
1288
1289if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1290then
1291        echo >&2 'You need to build test-tool:'
1292        echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1293        exit 1
1294fi
1295
1296# Test repository
1297rm -fr "$TRASH_DIRECTORY" || {
1298        GIT_EXIT_OK=t
1299        echo >&5 "FATAL: Cannot prepare test area"
1300        exit 1
1301}
1302
1303HOME="$TRASH_DIRECTORY"
1304GNUPGHOME="$HOME/gnupg-home-not-used"
1305export HOME GNUPGHOME
1306
1307if test -z "$TEST_NO_CREATE_REPO"
1308then
1309        test_create_repo "$TRASH_DIRECTORY"
1310else
1311        mkdir -p "$TRASH_DIRECTORY"
1312fi
1313
1314# Use -P to resolve symlinks in our working directory so that the cwd
1315# in subprocesses like git equals our $PWD (for pathname comparisons).
1316cd -P "$TRASH_DIRECTORY" || exit 1
1317
1318this_test=${0##*/}
1319this_test=${this_test%%-*}
1320if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1321then
1322        say_color info >&3 "skipping test $this_test altogether"
1323        skip_all="skip all tests in $this_test"
1324        test_done
1325fi
1326
1327if test -n "$write_junit_xml"
1328then
1329        junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1330        mkdir -p "$junit_xml_dir"
1331        junit_xml_base=${0##*/}
1332        junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1333        junit_attrs="name=\"${junit_xml_base%.sh}\""
1334        junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1335                date +%Y-%m-%dT%H:%M:%S)\""
1336        write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1337        junit_suite_start=$(test-tool date getnanos)
1338        if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1339        then
1340                GIT_TEST_TEE_OFFSET=0
1341        fi
1342fi
1343
1344# Provide an implementation of the 'yes' utility; the upper bound
1345# limit is there to help Windows that cannot stop this loop from
1346# wasting cycles when the downstream stops reading, so do not be
1347# tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1348# limit the output of the yes utility", 2016-02-02)
1349yes () {
1350        if test $# = 0
1351        then
1352                y=y
1353        else
1354                y="$*"
1355        fi
1356
1357        i=0
1358        while test $i -lt 99
1359        do
1360                echo "$y"
1361                i=$(($i+1))
1362        done
1363}
1364
1365# Fix some commands on Windows
1366uname_s=$(uname -s)
1367case $uname_s in
1368*MINGW*)
1369        # Windows has its own (incompatible) sort and find
1370        sort () {
1371                /usr/bin/sort "$@"
1372        }
1373        find () {
1374                /usr/bin/find "$@"
1375        }
1376        # git sees Windows-style pwd
1377        pwd () {
1378                builtin pwd -W
1379        }
1380        # no POSIX permissions
1381        # backslashes in pathspec are converted to '/'
1382        # exec does not inherit the PID
1383        test_set_prereq MINGW
1384        test_set_prereq NATIVE_CRLF
1385        test_set_prereq SED_STRIPS_CR
1386        test_set_prereq GREP_STRIPS_CR
1387        GIT_TEST_CMP=mingw_test_cmp
1388        ;;
1389*CYGWIN*)
1390        test_set_prereq POSIXPERM
1391        test_set_prereq EXECKEEPSPID
1392        test_set_prereq CYGWIN
1393        test_set_prereq SED_STRIPS_CR
1394        test_set_prereq GREP_STRIPS_CR
1395        ;;
1396*)
1397        test_set_prereq POSIXPERM
1398        test_set_prereq BSLASHPSPEC
1399        test_set_prereq EXECKEEPSPID
1400        ;;
1401esac
1402
1403( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1404test -z "$NO_PERL" && test_set_prereq PERL
1405test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1406test -z "$NO_PYTHON" && test_set_prereq PYTHON
1407test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1408test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1409test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1410test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1411
1412if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1413then
1414        GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1415        unset GIT_TEST_GETTEXT_POISON_ORIG
1416fi
1417
1418# Can we rely on git's output in the C locale?
1419if test -z "$GIT_TEST_GETTEXT_POISON"
1420then
1421        test_set_prereq C_LOCALE_OUTPUT
1422fi
1423
1424if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1425then
1426        GIT_TEST_CHECK_CACHE_TREE=true
1427        export GIT_TEST_CHECK_CACHE_TREE
1428fi
1429
1430test_lazy_prereq PIPE '
1431        # test whether the filesystem supports FIFOs
1432        test_have_prereq !MINGW,!CYGWIN &&
1433        rm -f testfifo && mkfifo testfifo
1434'
1435
1436test_lazy_prereq SYMLINKS '
1437        # test whether the filesystem supports symbolic links
1438        ln -s x y && test -h y
1439'
1440
1441test_lazy_prereq FILEMODE '
1442        test "$(git config --bool core.filemode)" = true
1443'
1444
1445test_lazy_prereq CASE_INSENSITIVE_FS '
1446        echo good >CamelCase &&
1447        echo bad >camelcase &&
1448        test "$(cat CamelCase)" != good
1449'
1450
1451test_lazy_prereq FUNNYNAMES '
1452        test_have_prereq !MINGW &&
1453        touch -- \
1454                "FUNNYNAMES tab embedded" \
1455                "FUNNYNAMES \"quote embedded\"" \
1456                "FUNNYNAMES newline
1457embedded" 2>/dev/null &&
1458        rm -- \
1459                "FUNNYNAMES tab embedded" \
1460                "FUNNYNAMES \"quote embedded\"" \
1461                "FUNNYNAMES newline
1462embedded" 2>/dev/null
1463'
1464
1465test_lazy_prereq UTF8_NFD_TO_NFC '
1466        # check whether FS converts nfd unicode to nfc
1467        auml=$(printf "\303\244")
1468        aumlcdiar=$(printf "\141\314\210")
1469        >"$auml" &&
1470        test -f "$aumlcdiar"
1471'
1472
1473test_lazy_prereq AUTOIDENT '
1474        sane_unset GIT_AUTHOR_NAME &&
1475        sane_unset GIT_AUTHOR_EMAIL &&
1476        git var GIT_AUTHOR_IDENT
1477'
1478
1479test_lazy_prereq EXPENSIVE '
1480        test -n "$GIT_TEST_LONG"
1481'
1482
1483test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1484        test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1485'
1486
1487test_lazy_prereq USR_BIN_TIME '
1488        test -x /usr/bin/time
1489'
1490
1491test_lazy_prereq NOT_ROOT '
1492        uid=$(id -u) &&
1493        test "$uid" != 0
1494'
1495
1496test_lazy_prereq JGIT '
1497        type jgit
1498'
1499
1500# SANITY is about "can you correctly predict what the filesystem would
1501# do by only looking at the permission bits of the files and
1502# directories?"  A typical example of !SANITY is running the test
1503# suite as root, where a test may expect "chmod -r file && cat file"
1504# to fail because file is supposed to be unreadable after a successful
1505# chmod.  In an environment (i.e. combination of what filesystem is
1506# being used and who is running the tests) that lacks SANITY, you may
1507# be able to delete or create a file when the containing directory
1508# doesn't have write permissions, or access a file even if the
1509# containing directory doesn't have read or execute permissions.
1510
1511test_lazy_prereq SANITY '
1512        mkdir SANETESTD.1 SANETESTD.2 &&
1513
1514        chmod +w SANETESTD.1 SANETESTD.2 &&
1515        >SANETESTD.1/x 2>SANETESTD.2/x &&
1516        chmod -w SANETESTD.1 &&
1517        chmod -r SANETESTD.1/x &&
1518        chmod -rx SANETESTD.2 ||
1519        BUG "cannot prepare SANETESTD"
1520
1521        ! test -r SANETESTD.1/x &&
1522        ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1523        status=$?
1524
1525        chmod +rwx SANETESTD.1 SANETESTD.2 &&
1526        rm -rf SANETESTD.1 SANETESTD.2 ||
1527        BUG "cannot clean SANETESTD"
1528        return $status
1529'
1530
1531test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1532GIT_UNZIP=${GIT_UNZIP:-unzip}
1533test_lazy_prereq UNZIP '
1534        "$GIT_UNZIP" -v
1535        test $? -ne 127
1536'
1537
1538run_with_limited_cmdline () {
1539        (ulimit -s 128 && "$@")
1540}
1541
1542test_lazy_prereq CMDLINE_LIMIT '
1543        test_have_prereq !MINGW,!CYGWIN &&
1544        run_with_limited_cmdline true
1545'
1546
1547run_with_limited_stack () {
1548        (ulimit -s 128 && "$@")
1549}
1550
1551test_lazy_prereq ULIMIT_STACK_SIZE '
1552        test_have_prereq !MINGW,!CYGWIN &&
1553        run_with_limited_stack true
1554'
1555
1556build_option () {
1557        git version --build-options |
1558        sed -ne "s/^$1: //p"
1559}
1560
1561test_lazy_prereq LONG_IS_64BIT '
1562        test 8 -le "$(build_option sizeof-long)"
1563'
1564
1565test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1566test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1567
1568test_lazy_prereq CURL '
1569        curl --version
1570'
1571
1572# SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1573# which will not work with other hash algorithms and tests that work but don't
1574# test anything meaningful (e.g. special values which cause short collisions).
1575test_lazy_prereq SHA1 '
1576        test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1577'
1578
1579test_lazy_prereq REBASE_P '
1580        test -z "$GIT_TEST_SKIP_REBASE_P"
1581'